!function(e) {
    var intervalTime = 3000; //ms
    var hrefUrl = e.location.href;
    var hostname = e.location.hostname;
    var pathname = e.location.pathname;
    var host = e.location.host;
    var pageTime = (new Date).getTime();

    e.startWebViewMonitor = function() {
        if (e.monitorStarted) return !1;
        e.monitorStarted = !0;

        setTimeout(function() {
            var navigationTiming = {
                url: hrefUrl,
                domain: hostname,
                path: pathname,
                navigationTiming: performanceTiming.getNavigationTiming()
            };
            sendResourceTiming(navigationTiming);
        }, 0);
    }

    function sendResourceTiming(e) {
        webMonitor.sendResource(JSON.stringify(e))
    };


    function sendErrors() {
        var err = errorMonitor.getError();
        if (err.length > 0) {
            var errorInfo = {
                url: hrefUrl,
                domain: hostname,
                path: pathname,
                errors: err
            };

            webMonitor.sendError(JSON.stringify(errorInfo))
        }
    };

    e.setInterval(
        function() {
            sendErrors();
        }, intervalTime
    );

    var performanceTiming = function() {
        function navigationTiming() {
            if (!e.performance || !e.performance.timing) return {};
            var time = e.performance.timing;
            return {
                navigationStart: time.navigationStart,
                redirectStart: time.redirectStart,
                redirectEnd: time.redirectEnd,
                fetchStart: time.fetchStart,
                domainLookupStart: time.domainLookupStart,
                domainLookupEnd: time.domainLookupEnd,
                connectStart: time.connectStart,
                secureConnectionStart: time.secureConnectionStart ? time.secureConnectionStart: time.connectEnd - time.secureConnectionStart,
                connectEnd: time.connectEnd,
                requestStart: time.requestStart,
                responseStart: time.responseStart,
                responseEnd: time.responseEnd,
                unloadEventStart: time.unloadEventStart,
                unloadEventEnd: time.unloadEventEnd,
                domLoading: time.domLoading,
                domInteractive: time.domInteractive,
                domContentLoadedEventStart: time.domContentLoadedEventStart,
                domContentLoadedEventEnd: time.domContentLoadedEventEnd,
                domComplete: time.domComplete,
                loadEventStart: time.loadEventStart,
                loadEventEnd: time.loadEventEnd,
                pageTime: pageTime
            }
        }

        return {
            cacheResourceTimingLength: 0,
            getNavigationTiming: function() {
                return navigationTiming();
            }
        }
    }();

    window.onload=function(){
        console.log("Monitor on load");
        setTimeout(function() {
            var navigationTiming = {
                url: hrefUrl,
                domain: hostname,
                path: pathname,
                navigationTiming: performanceTiming.getNavigationTiming()
            };
            sendResourceTiming(navigationTiming);
        }, 300);
    };

    document.addEventListener("DOMContentLoaded",function(){
        console.log("Monitor DOMContentLoaded");

        setTimeout(function() {
            var navigationTiming = {
                url: hrefUrl,
                domain: hostname,
                path: pathname,
                navigationTiming: performanceTiming.getNavigationTiming()
            };
            sendResourceTiming(navigationTiming);
        }, 300);
    });

    var errorMonitor = function() {
        var errors = [];
        return e.addEventListener && e.addEventListener("error",
            function(e) {
                var eInfo = {};
                eInfo.time = e.timeStamp || (new Date).getTime(),
                eInfo.url = e.filename,
                eInfo.msg = e.message,
                eInfo.line = e.lineno,
                eInfo.column = e.colno,
                e.error ? (eInfo.type = e.error.name, eInfo.stack = e.error.stack) : (eInfo.msg.indexOf("Uncaught ") > -1 ? eInfo.stack = eInfo.msg.split("Uncaught ")[1] + " at " + eInfo.url + ":" + eInfo.line + ":" + eInfo.column: eInfo.stack = eInfo.msg + " at " + eInfo.url + ":" + eInfo.line + ":" + eInfo.column, eInfo.type = eInfo.stack.slice(0, eInfo.stack.indexOf(":"))),
                eInfo.type.toLowerCase().indexOf("script error") > -1 && (eInfo.type = "ScriptError"),
                errors.push(eInfo);
            }, !1), {
            getError: function() {
                return errors.splice(0, errors.length);
            }
        }
    }();

} (this);